import { HTMLProps, IndexKey } from 'web-utility';
export type DataObject = Record<string, any>;
export interface VNode {
    key?: IndexKey;
    text?: string;
    selector?: string;
    tagName?: string;
    is?: string;
    props?: DataObject;
    style?: DataObject;
    children?: VNode[];
    node?: Node;
}
export declare class VDOMNode implements VNode {
    node: Node;
    text?: string;
    tagName?: string;
    is?: string;
    props?: DataObject;
    style?: DataObject;
    children?: VNode[];
    static selectorOf: (tagName: string, is?: string, className?: string) => string;
    get selector(): string;
    static propsMap: DataObject;
    static attrsMap: any;
    constructor(node: Node);
}
declare global {
    namespace JSX {
        type Element = VNode;
        type IntrinsicElements = {
            [tagName in keyof HTMLElementTagNameMap]: HTMLProps<HTMLElementTagNameMap[tagName]>;
        };
    }
}
