"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VDOMNode = void 0;
var VDOMNode = exports.VDOMNode = /** @class */ (function () {
    function VDOMNode(node) {
        var _b;
        this.node = node;
        if (node instanceof Text) {
            this.text = node.nodeValue;
            return;
        }
        if (!(node instanceof Element))
            return;
        var tagName = (_b = node, _b.tagName), attributes = _b.attributes, style = _b.style, childNodes = _b.childNodes;
        this.tagName = tagName.toLowerCase();
        this.is = node.getAttribute('is');
        var props = Array.from(attributes, function (_b) {
            var name = _b.name, value = _b.value;
            return name !== 'style' && [VDOMNode.attrsMap[name] || name, value];
        }).filter(Boolean);
        if (props[0])
            this.props = Object.fromEntries(props);
        var styles = Array.from(style, function (key) { return [key, style[key]]; });
        if (styles[0])
            this.style = Object.fromEntries(styles);
        var children = Array.from(childNodes, function (node) { return new VDOMNode(node); });
        if (children[0])
            this.children = children;
    }
    Object.defineProperty(VDOMNode.prototype, "selector", {
        get: function () {
            var _b;
            var tagName = (_b = this, _b.tagName), is = _b.is, props = _b.props;
            return tagName && VDOMNode.selectorOf(tagName, is, props === null || props === void 0 ? void 0 : props.className);
        },
        enumerable: false,
        configurable: true
    });
    var _a;
    _a = VDOMNode;
    VDOMNode.selectorOf = function (tagName, is, className) {
        return [
            tagName.toLowerCase(),
            className && ".".concat(className.trim().replace(/\s+/, '.')),
            is && "[is=\"".concat(is, "\"]")
        ]
            .filter(Boolean)
            .join('');
    };
    VDOMNode.propsMap = { className: 'class', htmlFor: 'for' };
    VDOMNode.attrsMap = Object.fromEntries(Object.entries(_a.propsMap).map(function (item) { return item.reverse(); }));
    return VDOMNode;
}());
