"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Fragment = exports.jsxs = exports.jsx = void 0;
var tslib_1 = require("tslib");
var web_utility_1 = require("web-utility");
var VDOM_1 = require("./dist/VDOM");
/**
 * @see {@link https://github.com/reactjs/rfcs/blob/createlement-rfc/text/0000-create-element-changes.md}
 * @see {@link https://babeljs.io/docs/babel-plugin-transform-react-jsx}
 */
function jsx(type, _a, key) {
    var _b;
    var is = _a.is, style = _a.style, children = _a.children, props = tslib_1.__rest(_a, ["is", "style", "children"]);
    if (typeof type === 'function' && (0, web_utility_1.isHTMLElementClass)(type))
        type = (0, web_utility_1.tagNameOf)(type);
    children = (_b = (children instanceof Array ? children : children && [children])) === null || _b === void 0 ? void 0 : _b.map(function (node) {
        return node instanceof Object
            ? node
            : node === 0 || node
                ? { text: node + '' }
                : { text: '' };
    });
    return typeof type === 'string'
        ? {
            key: key,
            selector: VDOM_1.VDOMNode.selectorOf(type, is, props.className),
            tagName: type,
            is: is,
            props: props,
            style: style,
            children: children
        }
        : type(tslib_1.__assign({ is: is, style: style, children: children }, props));
}
exports.jsx = jsx;
exports.jsxs = jsx;
/**
 * @see {@link https://babeljs.io/docs/babel-plugin-transform-react-jsx#react-automatic-runtime-1}
 */
var Fragment = function (_a) {
    var style = _a.style, children = _a.children, props = tslib_1.__rest(_a, ["style", "children"]);
    return ({
        props: props,
        style: style,
        children: children
    });
};
exports.Fragment = Fragment;
